	SUBROUTINE generate_variables

*	Generate random variables following user's prescription.
*	(COMPITO package)

	IMPLICIT NONE
	SAVE

      INCLUDE 'compito.inc'

	INTEGER i, jretry			! loop indices
	REAL r_var				! extracted value
	LOGICAL good1				! flag on user's limits
	LOGICAL good2				! flag on user's constraints

*	external functions
	REAL round				! rounding function
	REAL ran1				! random generator


*	Executable code


	CALL clear_constraint_statistics


	  DO jretry = 1, max_random_retry

	  good1 = .TRUE.

	    DO i = 1, nvar			! loop on random variables

*	    generate random variable
          r_var = ran1 (iseed)
	    r_var = rlow(i)  +  r_var * (rup(i) - rlow(i))

*	    round to number of significant digits
	    r_var = round (r_var, n_digits-1)

*	      check limits after rounding

	      IF (r_var .LT. rlow(i)  .OR.  r_var .GT. rup(i))  THEN

	        good1 = .FALSE.
	        noutlim(i) = noutlim(i) + 1

	      END IF


*	    store generated variable
	    random_value(i) = r_var

	    END DO

	  CALL test_constraint (good2)
	  CALL fill_constraint_statistics
	  
	  IF (good1 .AND. good2)  RETURN

	  END DO				! end loop on random variables


	PRINT *, ' '
	PRINT *, ' GENERATE_VARIABLES: too many retries'
	PRINT *, ' constraints are never satisfied after',
     &	        max_random_retry, ' random extractions'
	CALL type_constraint_statistics
	PRINT *, ' '
	CALL LIBSTOP (%VAL(ss_abort))

	END
