	SUBROUTINE prepare_format (xx, form, length, ixx, str, iform, go_tex)
	
*	This procedure writes the "optimal" format.
*	Input	-	xx, go_tex
*	Output	-	form, length, ixx, str, iform
*	(COMPITO package)
	
	IMPLICIT NONE
	SAVE
	
	INCLUDE 'compito.inc'
	
	
*	I/O parameters
	REAL xx			! IN:  real value
	LOGICAL go_tex		! IN:  enable TEX string output
	CHARACTER*8 form	! OUT: format string
	INTEGER length		! OUT: format length
	INTEGER ixx		! OUT: "xx" converted to integer
	CHARACTER*(*) str	! OUT: "xx" converted to string
	INTEGER iform		! OUT: conversion return code
				!      1 = integer
				!      2 = either F or E
				!      3 = string for TEX
	
*	other local variables
	INTEGER ninteger, ndecimal ! number of places for the
	INTEGER nsign, ntotal	! F format of a variable
	INTEGER intgr, ifrac, iex ! partial digits of "xx"
	INTEGER jpoi, jend, jlen ! character pointers
	LOGICAL big_enough	! flag
	LOGICAL small_enough	! flag
	CHARACTER*100 buff	! internal string
	LOGICAL E_flag		! E format internal flag
	CHARACTER*10 stringf	! format string
	
*	external functions
	INTEGER k_exp		! exponent in scientific notation
	
	
*	Executable code
	
	
	E_flag = .FALSE.
	
*	evaluate integer, decimal and total places for F format,
*	allowing one place for decimal dot
	ninteger = MAX (1, k_exp (xx))
	ndecimal = MAX (0, n_digits - k_exp (xx))
	nsign = MAX (0, NINT (-SIGN (1., xx)))
	ntotal = ninteger + ndecimal + nsign + 1
	
*       prepare format
	
	
	IF (ntotal .LE. max_format)  THEN
	   
	   iform = 2
	   length = ntotal
	   WRITE (form, 1000) ntotal, ndecimal
 1000	   FORMAT ('(F', I2, '.', I2, ')')
	   
	ELSE
	   
	   iform = 2
	   E_flag = .TRUE.
	   length = n_digits + nsign + 6
	   WRITE (form, 1100) length, n_digits
 1100	   FORMAT ('(E', I2, '.', I2, ')')
	   
	END IF
	
	big_enough = ABS (xx)  .GE.  (10. ** (n_digits-1))
	small_enough = ABS (xx)  .LT.  (10. ** (max_format-1))
	
	IF (big_enough .AND. small_enough)  THEN
	   
	   iform = 1
	   ixx = NINT (xx)
	   length = ninteger + nsign + 1
	   WRITE (form, 1200) length
 1200	   FORMAT ('(I', I2, '   ', ')')
	   
	END IF
	
	
	IF (go_tex .AND. E_flag)  THEN
	   
	   
	   iform = 3
	   length = n_digits + 7
	   WRITE (form, 1300) length, n_digits
 1300	   FORMAT ('(E', I2, '.', I2, ')')
	   WRITE (buff(1:length), form) xx
	   READ (buff(4:4), '(I1)') intgr
	   jpoi = 5
	   jlen = n_digits - 1
	   jend = jpoi + jlen - 1 
	   stringf = '(l1)'
	   stringf(3:3) = char(48+jlen)
c       READ (buff(jpoi:jend), stringf(1:4)) ifrac
	   if (jlen.gt.7) stop 'jlen'
c       READ (buff(jpoi:jend), '(I<jlen>)') ifrac
	   if(jlen.eq.1)then
	      READ (buff(jpoi:jend), '(I1)') ifrac
           else 
	      if(jlen.eq.2)then
		 READ (buff(jpoi:jend), '(I2)') ifrac
	      else 
		 if(jlen.eq.3)then
		    READ (buff(jpoi:jend), '(I3)') ifrac
		 else 
		    if(jlen.eq.4)then
		       READ (buff(jpoi:jend), '(I4)') ifrac
		    else 
		       if(jlen.eq.5)then
			  READ (buff(jpoi:jend), '(I5)') ifrac
		       else 
			  if(jlen.eq.6)then
			     READ (buff(jpoi:jend), '(I6)') ifrac
			  else 
			     if(jlen.eq.7)then
				READ (buff(jpoi:jend), '(I7)') ifrac
			     endif
			  endif
		       endif
		    endif
		 endif
	      endif
	   endif 
	   jpoi = jend + 2
	   jend = jpoi + 2
	   READ (buff(jpoi:jend), '(I3)') iex
	   str(1:2) = '$ '
	   IF (xx .LT. 0.) str(2:2) = '-'
	   WRITE (str(3:3), '(I1)') intgr
	   jend = 3
	   
	   IF (n_digits .GT. 1)  THEN
	      
	      jpoi = jend + 1
	      str(jpoi:jpoi) = '.'
	      jpoi = jpoi + 1
	      jend = jpoi + jlen - 1
	      stringf = '(l1.1)'
	      stringf(3:3) = char(48+jlen)
	      stringf(5:5) = char(48+jlen)
c       WRITE (str(jpoi:jend), stringf(1:6)) ifrac
	      if(jlen.gt.7)stop 'jlen'
c       WRITE (str(jpoi:jend), '(I<jlen>.<jlen>)') ifrac
	      if(jlen.eq.1)then
		 WRITE (str(jpoi:jend), '(I1.1)') ifrac
	      else 
		 if(jlen.eq.2)then
		    WRITE (str(jpoi:jend), '(I2.2)') ifrac
		 else 
		    if(jlen.eq.3)then
		       WRITE (str(jpoi:jend), '(I3.3)') ifrac
		    else 
		       if(jlen.eq.4)then
			  WRITE (str(jpoi:jend), '(I4.4)') ifrac
		       else 
			  if(jlen.eq.5)then
			     WRITE (str(jpoi:jend), '(I5.5)') ifrac
			  else 
			     if(jlen.eq.6)then
				WRITE (str(jpoi:jend), '(I6.6)') ifrac
			     else 
				if(jlen.eq.7)then		  
				   WRITE (str(jpoi:jend), '(I7.7)') ifrac
				endif
			     endif
			  endif
		       endif
		    endif
		 endif
	      endif 
	   END IF
	   
	   jpoi = jend + 1
	   jend = jpoi + 11
	   str(jpoi:jend) = ' \\times 10^{'
	   jpoi = jend + 1
	   jend = jpoi + 2
	   WRITE (str(jpoi:jend), '(I3)') iex-1
	   jpoi = jend + 1
	   jend = jpoi + 1
	   str(jpoi:jend) = '}$'
	   
*       set other output parameters
	   length = jend
	   WRITE (form, 1500) length
 1500	   FORMAT ('(A', I4, ' )')
	   
	   
	END IF
      
	
	RETURN
	
	END
	
