      PROGRAM process
      
*     This program generates individual tests (compiti)
*     from an input text and an input list of students.
*     (COMPITO package)
      
      
      IMPLICIT NONE
      
      INCLUDE 'compito.inc'
      
      INTEGER i                 ! DO loop index
      LOGICAL ok		! Control the generation of the answers
      REAL*4 RAN1,TMP
      INTEGER time
      
      
*     Executable code
      
      
      CALL init_compito		! initialize variables
      CALL user_interface       ! read in user parameters
      CALL read_text            ! read in text
      CALL find_variables       ! find all variables to be generated
      CALL show_variables       ! show variables and their ranges
      CALL find_questions       ! find the question lines in the text
      CALL read_names           ! read in student names
      
      IF (.NOT. many_outputs)  CALL open_out_file
      
*     open output student list file
      OPEN (UNIT=16, FILE='output_students', ACCESS='SEQUENTIAL',
     &     STATUS='NEW', FORM='FORMATTED') !, CARRIAGECONTROL='LIST')
      
*     open output data and result file
      OPEN (UNIT=17, FILE='results', ACCESS='SEQUENTIAL',
     &     STATUS='NEW', FORM='FORMATTED') !, CARRIAGECONTROL='LIST')
      
c      icomp = n_skip
C     
C     Randomize the single case we need
C     
      IF (n_spares.EQ.-1) THEN
C     Call the random function RAN1
         i  = -time()
C     Time in unix format
         tmp = ran1(i)
c         print *,i,tmp
         n_spares = -n_spares
      ENDIF

      DO i = 1, n_skip
         IF (MOD (i, 20) .EQ. 0)  PRINT *, ' Skipping', i
         icomp = icomp + 1      ! set current test number
         OK = .false.
         DO WHILE (.not.OK)
            CALL generate_variables ! draw random variables
            CALL evaluate_solution ! calculate solutions
            CALL generate_answers (OK) ! generates alternatives
         ENDDO
      ENDDO

      DO i = 1, n_named		! loop on named tests
         
         IF (MOD (i, 20) .EQ. 0)  PRINT *, ' Generating NAMED text', i
         
         icomp = icomp + 1      ! set current test number
         OK = .false.
         DO WHILE (.not.OK)
            CALL generate_variables ! draw random variables
c           print *,'named ',i
            CALL evaluate_solution ! calculate solutions
            CALL generate_answers (OK) ! generates alternatives
         ENDDO
         
         
         IF (tex)  THEN
            
            CALL put_numbers_on_tex
            
         ELSE
            
            CALL put_numbers_on_text ! put the numbers in
            
         END IF
         

         IF (many_outputs)  CALL open_out_file
         
         CALL init_named_text   ! write named text header
         CALL write_text        ! write the output text
         CALL close_text
         CALL write_name        ! write student name on list
         CALL write_results     ! store data and results
         
      END DO
      
***   
      
      DO i = 1+n_skip, n_spares        ! loop on spare tests
         
         IF (MOD (i, 20) .EQ. 0)  PRINT *, ' Generating UNNAMED text', i
         
         icomp = icomp + 1      ! set current test number
         OK = .false.
         DO WHILE (.not.OK)
            CALL generate_variables ! draw random variables
            CALL evaluate_solution ! calculate solutions
            CALL generate_answers	(OK) ! generates alternatives
         ENDDO
         
         
         IF (tex)  THEN
            
            CALL put_numbers_on_tex
            
         ELSE
            
            CALL put_numbers_on_text ! put the numbers in
            
         END IF
         
         
         IF (many_outputs)  CALL open_out_file
         
         CALL init_unnamed_text	! write unnamed text header
         CALL write_text        ! write the output text
         CALL close_text
         CALL write_spare_name  ! write default name on list
         CALL write_results     ! store data and results
         
      END DO
      
      IF (.NOT. many_outputs)  CALL close_out_file
      CLOSE (16)
      CLOSE (17)
      
      STOP 'Last processing phase: Normal successful completion'
      
      END
      
