	SUBROUTINE put_numbers_on_tex

*	This procedure puts the numerical values of the variables and
*	the proposed answers on the current out_text using TEX format.
*	(COMPITO package)

	IMPLICIT NONE
	SAVE

	INCLUDE 'compito.inc'

	CHARACTER*8 form	! format string

	INTEGER i, j		! loop indices
	INTEGER lin		! line number
	INTEGER lstr		! string length
	INTEGER n1, n2		! string pointers
	INTEGER jpoi, jend	! string pointers
	INTEGER jshift		! pointer shift
	INTEGER jnext		! pointer to remaining string
	INTEGER jtemp(max_var)	! pointers to variables
	REAL xvar		! random variable
	REAL rin		! real alternative
	INTEGER iout		! integer version of random variable for output
	LOGICAL ifor		! flag on integer format for output variable
	CHARACTER*100 str	! local string

*	external function
	INTEGER k_exp		! exponent in scientific (decimal) notation


*	Executable code


*	  copy text on output text

	  DO i = 1, last_text
	  out_text(i) = text(i)
	  lout(i) = ltex(i)
	  END DO


*	  duplicate pointers to variables

	  DO i = 1, nvar
	  jtemp(i) = jfirst(i)
	  END DO


*	  complete output text with numbers and alternative answers


	  DO 10000, i = 1, nvar			! loop on variables

*	  store i-dependent quantities for easy reference in the following
	  lin = linevar(i)
	  n1 = jtemp(i) - 1
	  xvar = random_value(i)
	  string = out_text(lin)
	  lstr = lout(lin)
	  jnext = jtemp(i) + lv(i) + 1
CCC	  CALL prepare_format (xvar, .TRUE., form, jshift, iout, ifor)
	  CALL prepare_format (xvar, form, jshift, iout, str, ifor, tex)
	  n2 = n1 + jshift - 1

CCC*	    rewrite text line
CCC
CCC	    IF (ifor)  THEN
CCC
CCC	      WRITE (out_text(lin)(n1:n2), form) iout
CCC
CCC	    ELSE
CCC
CCC	      WRITE (out_text(lin)(n1:n2), form) xvar
CCC
CCC	    END IF

	    CALL put_number (out_text(lin)(n1:n2), ifor,
     &	                     iout, xvar, str(1:jshift), form)

	  jshift = jshift  -  (lv(i) + 2)
	  lout(lin) = lout(lin)  +  jshift
	  IF (jnext .LE. lstr)
     &	   out_text(lin)(n2+1:lout(lin)) = string(jnext:lstr)

*	    restore pointers

	    DO j = i+1, nvar
	    IF (linevar(j) .EQ. linevar(i))  jtemp(j) = jtemp(j) + jshift
	    END DO


10000	  CONTINUE				! end of loop on variables


	  DO 20000, i = 1, n_questions		! loop on questions

*	  store line number for easy reference
	  lin = line_question(i)
C
C Added by R Mannella to handle literal answers
          IF (.NOT.lit_ans(i)) THEN
	     if (bot_ans(i)) THEN
	  out_text(lin)(1:41) = 
     1       '\\put(2,-3){\\framebox(50,9){}} \\hskip 60mm'
	  ELSE
	  out_text(lin)(1:41) = 
     1       '\\put(2,-3){\\framebox(20,9){}} \\hskip 30mm'
	  ENDIF
	  lout(lin) = 41

	    DO j = 1, n_alternatives

	    rin = altern(i,j)
	    CALL prepare_format (rin, form, jshift, iout, str, ifor, tex)
	    jpoi = 1
	    jend = jpoi + 7
	    WRITE (add(i, j)(jpoi:jend), '(A1, A7)') letter(j), ' \\fbox{'
	    jpoi = jend + 1
	    jend = jend + jshift
	    CALL put_number (add(i, j)(jpoi:jend), ifor,
     &	                     iout, rin, str(1:jshift), form)
	    jpoi = jend + 1
	    jend = jend + 13
	    WRITE (add(i, j)(jpoi:jend), '(A13)') '} \\hskip 11pt'
	    ladd(i, j) = jend

	    END DO

           ELSE
            out_text(lin)(1:41) = 
     1       '\\put(2,-3){\\framebox(80,9){}} \\hskip 30mm'
            lout(lin) = 41
           ENDIF

20000	  CONTINUE				! end of loop on questions


	RETURN

	END
