	SUBROUTINE put_numbers_on_text

*	This procedure puts the numerical values of the variables
*	and the proposed answers on the current out_text
*	(COMPITO package)

	IMPLICIT NONE
	SAVE

	INCLUDE 'compito.inc'
c	INCLUDE 'parameters.inc'

	CHARACTER*8 form	! format string

	INTEGER i, j		! loop indices
	INTEGER lin		! line number
	INTEGER lstr		! string length
	INTEGER n1, n2		! string pointers
	INTEGER jpoi, jend	! string pointers
	INTEGER jshift		! pointer shift
	INTEGER jnext		! pointer to remaining string
	INTEGER jtemp(max_var)	! pointers to variables
	REAL xvar		! random variable
	INTEGER iout		! integer version of random variable for output
	INTEGER ifor		! encoded format for output variable
				! 1 = integer
				! 2 = F or E
				! 3 = TEX string
	CHARACTER*100 str	! dummy string

*	external function
	INTEGER k_exp		! exponent in scientific (decimal) notation


*	Executable code


*	  copy text on output text

	  DO i = 1, last_text
	  out_text(i) = text(i)
	  lout(i) = ltex(i)
	  END DO


*	  duplicate pointers to variables

	  DO i = 1, nvar
	  jtemp(i) = jfirst(i)
	  END DO


*	  complete output text with numbers and alternative answers


	  DO 10000, i = 1, nvar			! loop on variables

*	  store i-dependent quantities for easy reference in the following
	  lin = linevar(i)
	  n1 = jtemp(i) - 1
	  xvar = random_value(i)
	  string = out_text(lin)
	  lstr = lout(lin)
	  jnext = jtemp(i) + lv(i) + 1
	  CALL prepare_format (xvar, form, jshift, iout, str, ifor, .FALSE.)
	  n2 = n1 + jshift - 1

*	  rewrite text line
	  CALL put_number (out_text(lin)(n1:n2), ifor,
     &	                   iout, xvar, str(1:jshift), form)

	  jshift = jshift  -  (lv(i) + 2)
	  lout(lin) = lout(lin)  +  jshift
	  IF (jnext .LE. lstr)
     &	   out_text(lin)(n2+1:lout(lin)) = string(jnext:lstr)

*	    restore pointers

	    DO j = i+1, nvar
	    IF (linevar(j) .EQ. linevar(i))  jtemp(j) = jtemp(j) + jshift
	    END DO


10000	  CONTINUE				! end of loop on variables


	  DO 20000, i = 1, n_questions		! loop on questions

*	  store line number for easy reference
	  lin = line_question(i)

C	  WRITE (out_text(lin)(1:2), '(A2)')  '  '

*	  initialize string pointer
	  jpoi = 1

	    DO j = 1, n_alternatives

	    jend = jpoi + 2
	    WRITE (out_text(lin)(jpoi:jend), '(A,A2)') letter(j), ') '
	    CALL prepare_format (altern(i,j), form, jshift, iout, str, ifor,
     &	                         .FALSE.)
	    jpoi = jpoi + 3
	    jend = jpoi + jshift - 1

	    CALL put_number (out_text(lin)(jpoi:jend), ifor,
     &	                     iout, altern(i,j), str(1:jshift), form)

	    jpoi = jpoi + jshift
	    jend = jpoi + 3
	    WRITE (out_text(lin)(jpoi:jend), '(A4)') '    '
	    jpoi = jpoi + 4

	    END DO

	  lout(lin) = jend - 4

20000	  CONTINUE				! end of loop on questions


	RETURN

	END
