      SUBROUTINE read_text

*      Read in input text for the tests, including variables' ranges.
*      (COMPITO package)


      IMPLICIT NONE 
      SAVE

      INCLUDE 'compito.inc'

*      local variables
      INTEGER i            ! DO loop index
      INTEGER nchar        ! number of text line characters
      INTEGER iret         ! return code
      INTEGER jpoi         ! character string pointer
      INTEGER ktext        ! DO loop index

*     external functions
      INTEGER STRUPCASE         ! Convert to uppercase (Run-time library)
      INTEGER ICHAR
      
*     Executable code
      
      
*     open input text
      OPEN (UNIT=10, FILE='INPUT_TEXT', ACCESS='SEQUENTIAL',
     &     STATUS='OLD', FORM='FORMATTED') ! , READONLY)
      
      
*     read in input text

      last_text = 0

      DO i = 1, max_line        ! text line loop
         
         
*     read in next text line
C     READ (10, '(Q, (A))', END=10000) nchar, text(i)
         READ (10, 991, END=10000) text(i)
         nchar = 0
         do ktext=1,200    
            if(ichar(text(i)(ktext:ktext)).ne.32)nchar=ktext
         enddo
 991     format(A)
C     
         
*     convert null lines into one-blank lines
         
         IF (nchar .EQ. 0)  THEN
            
            nchar = 1
            text(i)(1:1) = ' '
            
         END IF
         
         
*     check that whole text line was read in
         
         IF (nchar .GT. max_char)  THEN
            
            PRINT *, ' '
            PRINT *, ' READ_TEXT: error reading TEXT line', i
            
            IF (i .EQ. 1)  THEN
               
               PRINT *, ' first text line'
               
            ELSE
               
               PRINT *, ' after line ', text(i-1)(1:ltex(i-1))
               
            END IF
            
            PRINT *, ' number of line characters:', nchar
            PRINT *, ' maximum allowed characters max_char:', max_char
            PRINT *, ' '
            CALL LIBSTOP (%VAL(ss_abort))
            
         END IF
         
         
c         last_text = i          ! store last line
         last_text = last_text + 1
         ltex(i) = nchar        ! store line length
         
         
*     check if last read line indicates end of text
         
         iret = STRUPCASE (string, text(i), len(text(i)))
         jpoi = INDEX (string, end_text)
         
         IF (jpoi .NE. 0)  THEN
            
            last_text = last_text - 1
            GO TO 20000
            
         END IF
         
         
      END DO                    ! end text line loop
      
      
*     no end-of-text found
      
      PRINT *, ' '
      PRINT *, ' READ_TEXT: too many TEXT lines'
      PRINT *, ' maximum allowed lines max_line:', max_line
      PRINT *, ' '
      CALL LIBSTOP (%VAL(ss_abort))
      
      
*     error handling: end of input text file detected
      
10000 CONTINUE
      
      PRINT *, ' '
      PRINT *, ' READ_TEXT: end of file reached, end of TEXT not found'
      PRINT *, ' end control word not found (end_text): ', end_text
      PRINT *, ' control word length:', LEN(end_text)
      PRINT *, ' '
      CALL LIBSTOP (%VAL(ss_abort))
      
      
20000 CONTINUE
      
*     read in ranges for variables

	  DO i = 1, max_line			! range line loop

*	  read in next line
c  READ (10, '(Q, (A))', END=30000) nchar, range(i)
	  READ(10, 991, END=30000) range(i)
          nchar = 0
          do ktext=1,200
             if(ichar(range(i)(ktext:ktext)).ne.32)nchar=ktext
          enddo

*	    convert null lines into one-blank lines

	    IF (nchar .EQ. 0)  THEN

	      nchar = 1
	      range(i)(1:1) = ' '

	    END IF


*	    check line was correctly read in

	    IF (nchar .EQ. 0)  THEN

	      PRINT *, ' '
	      PRINT *, ' READ_TEXT: null line in RANGE section'
	      PRINT *, ' line number', i
	      PRINT *, ' '
	      CALL LIBSTOP (%VAL(ss_abort))
                                             
	    ELSE IF (nchar .GT. max_char)  THEN

	      PRINT *, ' '
	      PRINT *, ' READ_TEXT: error reading RANGE line', i

	        IF (i .EQ. 1)  THEN

	          PRINT *, ' after last TEXT line'

	        ELSE

	          PRINT *, ' after line ', range(i-1)(1:lran(i-1))

	        END IF

	      PRINT *, ' number of line characters:', nchar
	      PRINT *, ' maximum allowed characters max_char:', max_char
	      PRINT *, ' '
	      CALL LIBSTOP (%VAL(ss_abort))

	    END IF

	  last_range = i			! store last line
	  lran(i) = nchar			! store line length


*	  check if last read line indicates end of range
            
	  iret = STRUPCASE (string, range(i), len(range(i)))
	  jpoi = INDEX (string, end_range)

	    IF (jpoi .NE. 0)  THEN

	      last_range = last_range - 1
	      GO TO 40000

	    END IF


	  END DO				! end range line loop


*	no end-of-range found

      PRINT *, ' '
      PRINT *, ' READ_TEXT: too many RANGE lines'
      PRINT *, ' maximum allowed lines (max_line):', max_line
      PRINT *, ' '
      CALL LIBSTOP (%VAL(ss_abort))


*	error handling: end of input file detected

30000	CONTINUE

      PRINT *, ' '
      PRINT *, ' READ_TEXT: end of file reached, end of RANGE not found'
      PRINT *, ' end control word not found (end_range): ', end_range
      PRINT *, ' control word length:', LEN(end_range)
      PRINT *, ' '
      CALL LIBSTOP (%VAL(ss_abort))


40000	CONTINUE

*	  read in solutions

	  DO i = 1, max_line			! solution line loop

*	  read in next line
c  READ (10, '(Q, (A))', END=50000) nchar, solve(i)
           READ(10, 991, END=50000) solve(i)
           nchar = 0
           do ktext=1,200
              if(ichar(solve(i)(ktext:ktext)).ne.32)nchar=ktext
           enddo

*	    convert null lines into one-blank lines

	    IF (nchar .EQ. 0)  THEN

	      nchar = 1
	      solve(i)(1:1) = ' '

	    END IF


*	    check that whole line was read in
                                             
	    IF (nchar .GT. max_char)  THEN

	      PRINT *, ' '
	      PRINT *, ' READ_TEXT: error reading SOLUTION line', i

	        IF (i .EQ. 1)  THEN

	          PRINT *, ' after last RANGE line'

	        ELSE

	          PRINT *, ' after line ', solve(i-1)(1:lsol(i-1))

	        END IF

	      PRINT *, ' number of line characters:', nchar
	      PRINT *, ' maximum allowed characters max_char:', max_char
	      PRINT *, ' '
	      CALL LIBSTOP (%VAL(ss_abort))

	    END IF

	  last_solve = i			! store last line
	  lsol(i) = nchar			! store line length


*	  check if last read line indicates end of solution
            
	  iret = STRUPCASE (string, solve(i), len(solve(i)))
	  jpoi = INDEX (string, end_solve)

	    IF (jpoi .NE. 0)  THEN

	      last_solve = last_solve - 1
	      GO TO 60000

	    END IF


	  END DO				! end solution line loop


*	no end-of-solution found

      PRINT *, ' '
      PRINT *, ' READ_TEXT: too many SOLUTION lines'
      PRINT *, ' maximum allowed lines (max_line):', max_line
      PRINT *, ' '
      CALL LIBSTOP (%VAL(ss_abort))


*	error handling: end of input file detected

50000	CONTINUE

      PRINT *, ' '
      PRINT *, ' READ_TEXT: end of file reached, end of 
     & SOLUTION not found'
      PRINT *, ' end control word not found (end_solve): ', end_solve
      PRINT *, ' control word length:', LEN(end_solve)
      PRINT *, ' '
      CALL LIBSTOP (%VAL(ss_abort))


60000	CONTINUE

*	  read in constraints

	  DO i = 1, max_line			! constraint line loop

*	  read in next line
c	  READ (10, '(Q, (A))', END=70000) nchar, cons(i)
          READ (10, 991, END=70000) cons(i)
          nchar=0
          do ktext=1,200
             if(ichar(cons(i)(ktext:ktext)).ne.32)nchar=ktext
          enddo

*	    convert null lines into one-blank lines

	    IF (nchar .EQ. 0)  THEN

	      nchar = 1
	      cons(i)(1:1) = ' '

	    END IF


*	    check that whole line was read in
                                             
	    IF (nchar .GT. max_char)  THEN

	      PRINT *, ' '
	      PRINT *, ' READ_TEXT: error reading CONSTRAINT line', i

	        IF (i .EQ. 1)  THEN

	          PRINT *, ' after last SOLUTION line'

	        ELSE

	          PRINT *, ' after line ', cons(i-1)(1:lcon(i-1))

	        END IF

	      PRINT *, ' number of line characters:', nchar
	      PRINT *, ' maximum allowed characters max_char:', max_char
	      PRINT *, ' '
	      CALL LIBSTOP (%VAL(ss_abort))

	    END IF

	  last_cons = 	i			! store last line
	  lcon(i) = nchar			! store line length


*	  check if last read line indicates end of constraint
            
	  iret = STRUPCASE (string, cons(i), len(cons(i)))
	  jpoi = INDEX (string, end_cons)

	    IF (jpoi .NE. 0)  THEN

	      last_cons = last_cons - 1
	      GO TO 80000

	    END IF


	  END DO				! end solution line loop


*	no end-of-constraint found

      PRINT *, ' '
      PRINT *, ' READ_TEXT: too many CONSTRAINT lines'
      PRINT *, ' maximum allowed lines (max_line):', max_line
      PRINT *, ' '
      CALL LIBSTOP (%VAL(ss_abort))


*	error handling: end of input file detected

70000	CONTINUE

      PRINT *, ' '
      PRINT *, ' READ_TEXT: end of file reached, end of 
     & CONSTRAINT not found'
      PRINT *, ' end control word not found (end_cons): ', end_cons
      PRINT *, ' control word length:', LEN(end_cons)
      PRINT *, ' '
      CALL LIBSTOP (%VAL(ss_abort))


80000	CONTINUE


*	  read in forced solutions

	  DO i = 1, max_line			! forced line loop

*	  read in next line
c	  READ (10, '(Q, (A))', END=70001) nchar, forc(i)
          read (10, 991, END=70001) forc(i)
          nchar = 0 
          do ktext=1,200
             if(ichar(forc(i)(ktext:ktext)).ne.32) nchar=ktext
          enddo

*	    convert null lines into one-blank lines

	    IF (nchar .EQ. 0)  THEN

	      nchar = 1
	      forc(i)(1:1) = ' '

	    END IF


*	    check that whole line was read in
                                             
	    IF (nchar .GT. max_char)  THEN

	      PRINT *, ' '
	      PRINT *, ' READ_TEXT: error reading FORCED line', i

	        IF (i .EQ. 1)  THEN

	          PRINT *, ' after last SOLUTION line'

	        ELSE

	          PRINT *, ' after line ', forc(i-1)(1:lfor(i-1))

	        END IF

	      PRINT *, ' number of line characters:', nchar
	      PRINT *, ' maximum allowed characters max_char:', max_char
	      PRINT *, ' '
	      CALL LIBSTOP (%VAL(ss_abort))

	    END IF

	  last_forc = 	i			! store last line
	  lfor(i) = nchar			! store line length


*	  check if last read line indicates end of constraint
            
	  iret = STRUPCASE (string, forc(i), len(forc(i)))
	  jpoi = INDEX (string, end_forc)

	    IF (jpoi .NE. 0)  THEN

	      last_forc = last_forc - 1
	      GO TO 80001

	    END IF


	  END DO				! end solution line loop


*	no end-of-constraint found

      PRINT *, ' '
      PRINT *, ' READ_TEXT: too many FORCED lines'
      PRINT *, ' maximum allowed lines (max_line):', max_line
      PRINT *, ' '
      CALL LIBSTOP (%VAL(ss_abort))


*      error handling: end of input file detected

70001	CONTINUE

      PRINT *, ' '
      PRINT *, ' READ_TEXT: end of file reached, end of 
     & FORCED not found'
      PRINT *, ' end control word not found (end_forc): ', end_forc
      PRINT *, ' control word length:', LEN(end_forc)
      PRINT *, ' '
      CALL LIBSTOP (%VAL(ss_abort))


80001	CONTINUE

      CLOSE (10)


      RETURN

      END
