	SUBROUTINE write_results

*	This routine stores the data and the results in the result file
*	(COMPITO package)

	IMPLICIT NONE
	SAVE

	INCLUDE 'compito.inc'
	INTEGER i, j			! loop indices
	INTEGER n1, n2, n3
	INTEGER ind
	INTEGER length
	INTEGER nout, nrem
	REAL xvar
	INTEGER iout			! integer version of variable for output
c	LOGICAL ifor			! flag on integer format for variable
 	INTEGER ifor			! flag on integer format for variable
	CHARACTER*8 form		! format string
	CHARACTER*80 var_names		! output string
	CHARACTER*80 var_values		! output string
	CHARACTER*100 str		! dummy string
        INTEGER first,line_count
  
        DATA first,line_count /0,1/

*	Executable code


	  IF (LEN(var(1)) .GT. 15)  THEN

	    PRINT *, ' '
	    PRINT *, ' WRITE_RESULTS: internal code error'
	    PRINT *, ' declared length of variable names (var) greater than 15'
	    PRINT *, ' '
	    CALL LIBSTOP(%VAL(ss_abort))

	  END IF


	WRITE (17, *)     ' '
	WRITE (17, '(A)') 'section 1: DATA'
        IF (first .EQ. 0) line_count = line_count + 2


	nout = nvar / 5			! put 5 variables per line
	nrem = MOD (nvar, 5)		! number of remaining variables


	  DO i = 1, nout		! loop on 5-variable lines

	    DO j = 1, 80
	    var_names(j:j) = ' '
	    var_values(j:j) = ' '
	    END DO

	    DO j = 1, 5

	    ind = j  +  5 * (i-1)
	    xvar = random_value(ind)
CCC	    CALL prepare_format (xvar, .TRUE., form, length, iout, ifor)
	    CALL prepare_format (xvar, form, length, iout, str, ifor, .FALSE.)

	      IF (length .GT. 15)  THEN

	        PRINT *, ' '
	        PRINT *, ' WRITE RESULTS: too many characters for this value'
	        PRINT *, ' probably the requested precision is too high'
	        PRINT *, ' generating too many significant digits'
	        PRINT *, ' precision:', precision
	        PRINT *, ' number of significant digits:', n_digits
	        PRINT *, ' variable number:', ind
	        PRINT *, ' variable name:', sav(ind)(1:lv(ind))
	        PRINT *, ' variable value:', xvar
	        PRINT *, ' '
	        CALL LIBSTOP(%VAL(ss_abort))

	      END IF

	    n1 = 1  +  16 * (j-1)
	    n2 = n1 + lv(ind)
	    n3 = n1 + length - 1
	    WRITE (var_names(n1:n2), '(A)')  sav(ind)(1:lv(ind))

	      IF (ifor.eq.1)  THEN

	        WRITE (var_values(n1:n3), form)  iout

	      ELSE

	        WRITE (var_values(n1:n3), form)  xvar

	      END IF

	    END DO

	  WRITE (17, '(A)') var_names		! output string
	  WRITE (17, '(A)') var_values		! output string
          IF (first .EQ. 0) line_count = line_count + 2

	  END DO			! end of loop on 5-variable lines

***

	  IF (nrem .NE. 0)  THEN

	    DO j = 1, 80
	    var_names(j:j) = ' '
	    var_values(j:j) = ' '
	    END DO

	    DO j = 1, nrem

	    ind = j  +  5 * nout
	    xvar = random_value(ind)
CCC	    CALL prepare_format (xvar, .TRUE., form, length, iout, ifor)
	    CALL prepare_format (xvar, form, length, iout, str, ifor, .FALSE.)

	      IF (length .GT. 15)  THEN

	        PRINT *, ' '
	        PRINT *, ' WRITE RESULTS: too many characters for this value'
	        PRINT *, ' probably the requested precision is too high'
	        PRINT *, ' generating too many significant digits'
	        PRINT *, ' precision:', precision
	        PRINT *, ' number of significant digits:', n_digits
	        PRINT *, ' variable number:', ind
	        PRINT *, ' variable name:', sav(ind)(1:lv(ind))
	        PRINT *, ' variable value:', xvar
	        PRINT *, ' '
	        CALL LIBSTOP(%VAL(ss_abort))

	      END IF

	    n1 = 1  +  16 * (j-1)
	    n2 = n1 + lv(ind)
	    n3 = n1 + length - 1
	    WRITE (var_names(n1:n2), '(A)')  sav(ind)(1:lv(ind))

	      IF (ifor.eq.1)  THEN

	        WRITE (var_values(n1:n3), form)  iout

	      ELSE

	        WRITE (var_values(n1:n3), form)  xvar

	      END IF

	    END DO

	   WRITE (17, '(A)') var_names		! output string
	   WRITE (17, '(A)') var_values		! output string
           IF (first .EQ. 0) line_count = line_count + 2

	  END IF


	WRITE (17, *)     ' '
	WRITE (17, '(A)') 'section 2: SOLUTIONS'
        IF (first .EQ. 0) line_count = line_count + 2


	nout = n_questions / 5			! put 5 solutions per line
	nrem = MOD (n_questions, 5)		! number of remaining solutions


	  DO i = 1, nout		! loop on output lines

	    DO j = 1, 80
	    var_values(j:j) = ' '
	    END DO

	    DO j = 1, 5

	    ind = j  +  5 * (i-1)
	    xvar = solution(ind)

CCC	    CALL prepare_format (xvar, .TRUE., form, length, iout, ifor)
	    CALL prepare_format (xvar, form, length, iout, str, ifor, .FALSE.)

	      IF (length .GT. 15)  THEN

	        PRINT *, ' '
	        PRINT *, ' WRITE RESULTS: too many characters for this value'
	        PRINT *, ' probably the requested precision is too high'
	        PRINT *, ' generating too many significant digits'
	        PRINT *, ' precision:', precision
	        PRINT *, ' number of significant digits:', n_digits
	        PRINT *, ' solution number:', ind
	        PRINT *, ' solution value:', xvar
	        PRINT *, ' '
	        CALL LIBSTOP(%VAL(ss_abort))

	      END IF

	    n1 = 1  +  16 * (j-1)
	    n3 = n1 + length  - 1

	      IF (ifor.eq.1)  THEN
	        WRITE (var_values(n1:n3), form)  iout
c		print *,'dentro iout',iout,n1,n3,var_values(n1:n3)
	      ELSE
	        WRITE (var_values(n1:n3), form)  xvar
c		print *,'dentro xvar',xvar,n1,n3,var_values(n1:n3)

	      END IF

	    END DO

	  WRITE (17, '(A)') var_values		! output string
          IF (first .EQ. 0) line_count = line_count + 1

	  END DO			! end of loop on output lines

***

	  IF (nrem .NE. 0)  THEN

	    DO j = 1, 80
	    var_values(j:j) = ' '
	    END DO

	    DO j = 1, nrem

	    ind = j  +  5 * nout
	    xvar = solution(ind)
CCC	    CALL prepare_format (xvar, .TRUE., form, length, iout, ifor)
	    CALL prepare_format (xvar, form, length, iout, str, ifor, .FALSE.)

	      IF (length .GT. 15)  THEN

	        PRINT *, ' '
	        PRINT *, ' WRITE RESULTS: too many characters for this value'
	        PRINT *, ' probably the requested precision is too high'
	        PRINT *, ' generating too many significant digits'
	        PRINT *, ' precision:', precision
	        PRINT *, ' number of significant digits:', n_digits
	        PRINT *, ' solution number:', ind
	        PRINT *, ' solution value:', xvar
	        PRINT *, ' '
	        CALL LIBSTOP(%VAL(ss_abort))

	      END IF

	    n1 = 1  +  16 * (j-1)
	    n3 = n1 + length - 1

	      IF (ifor.eq.1)  THEN

	        WRITE (var_values(n1:n3), form)  iout

	      ELSE

	        WRITE (var_values(n1:n3), form)  xvar

	      END IF

	    END DO

	   WRITE (17, '(A)') var_values		! output string
          IF (first .EQ. 0) line_count = line_count + 1

	  END IF

C Added by RM: write forced answers

c      IF (n_forced .GT. 0) THEN
	WRITE (17, *)     ' '
	WRITE (17, '(A)') 'section 3: FORCED ANSWERS'
        IF (first .EQ. 0) line_count = line_count + 2


      IF (n_forced .gt. 0) THEN
	nout = n_forced / 5			! put 5 solutions per line
	nrem = MOD (n_forced, 5)		! number of remaining solutions


	  DO i = 1, nout		! loop on output lines

	    DO j = 1, 80
	    var_values(j:j) = ' '
	    END DO

	    DO j = 1, 5

	    ind = j  +  5 * (i-1)
	    xvar = forced_a(ind)
CCC	    CALL prepare_format (xvar, .TRUE., form, length, iout, ifor)
	    CALL prepare_format (xvar, form, length, iout, str, ifor, .FALSE.)

	      IF (length .GT. 15)  THEN

	        PRINT *, ' '
	        PRINT *, ' WRITE FORCED: too many characters for this value'
	        PRINT *, ' probably the requested precision is too high'
	        PRINT *, ' generating too many significant digits'
	        PRINT *, ' precision:', precision
	        PRINT *, ' number of significant digits:', n_digits
	        PRINT *, ' solution number:', ind
	        PRINT *, ' solution value:', xvar
	        PRINT *, ' '
	        CALL LIBSTOP(%VAL(ss_abort))

	      END IF

	    n1 = 1  +  16 * (j-1)
	    n3 = n1 + length - 1

	      IF (ifor.eq.1)  THEN

	        WRITE (var_values(n1:n3), form)  iout

	      ELSE

	        WRITE (var_values(n1:n3), form)  xvar

	      END IF

	    END DO

	  WRITE (17, '(A)') var_values		! output string
          IF (first .EQ. 0) line_count = line_count + 1

	  END DO			! end of loop on output lines

***

	  IF (nrem .NE. 0)  THEN

	    DO j = 1, 80
	    var_values(j:j) = ' '
	    END DO

	    DO j = 1, nrem

	    ind = j  +  5 * nout
	    xvar = forced_a(ind)
CCC	    CALL prepare_format (xvar, .TRUE., form, length, iout, ifor)
	    CALL prepare_format (xvar, form, length, iout, str, ifor, .FALSE.)

	      IF (length .GT. 15)  THEN

	        PRINT *, ' '
	        PRINT *, ' WRITE FORCED: too many characters for this value'
	        PRINT *, ' probably the requested precision is too high'
	        PRINT *, ' generating too many significant digits'
	        PRINT *, ' precision:', precision
	        PRINT *, ' number of significant digits:', n_digits
	        PRINT *, ' solution number:', ind
	        PRINT *, ' solution value:', xvar
	        PRINT *, ' '
	        CALL LIBSTOP(%VAL(ss_abort))

	      END IF

	    n1 = 1  +  16 * (j-1)
	    n3 = n1 + length - 1

	      IF (ifor.eq.1)  THEN

	        WRITE (var_values(n1:n3), form)  iout

	      ELSE

	        WRITE (var_values(n1:n3), form)  xvar

	      END IF

	    END DO

	   WRITE (17, '(A)') var_values		! output string
          IF (first .EQ. 0) line_count = line_count + 1

	  END IF

      END IF
	WRITE (17, *)     ' '
	WRITE (17, '(A)') 'section 4: CHECKS'
        IF (first .EQ. 0) line_count = line_count + 2

c      else
c   	WRITE (17, *)     ' '
c	WRITE (17, '(A)') 'section 3: CHECKS'
c      endif    

C End addition

	  IF (max_question .GT. 40)  THEN

	    PRINT *, ' '
	    PRINT *, ' WRITE_RESULTS: internal code error'
	    PRINT *, ' maximum number of questions is too large'
	    PRINT *, ' parameter max_questions:', max_question
	    PRINT *, ' allowed maximum is: 40'
	    PRINT *, ' '
	    CALL LIBSTOP(%VAL(ss_abort))

	  END IF

***

	  DO j = 1, 80
	  var_names(j:j) = ' '
	  END DO

	  DO i = 1, n_questions
	  n1 = 1  +  2 * (i-1)
	  WRITE (var_names(n1:n1), '(A)')  letter(icorrect(i))
	  END DO

	WRITE (17, '(A)') var_names
	write (38,1212) icomp,var_names
 1212	format(1x,i5,4x,a60)
        IF (first .EQ. 0) line_count = line_count + 1

c	WRITE (17, *)     ' '
c	WRITE (17, '(A)')
c     &	 '************************************************************'
c	WRITE (17, *)     ' '

C Write the forced answers

	WRITE (17, *)     ' '
	WRITE (17, '(A)') 'section 5: FORCED CHECKS'
        IF (first .EQ. 0) line_count = line_count + 2


C End addition

	  IF (max_forced .GT. 25)  THEN

	    PRINT *, ' '
	    PRINT *, ' WRITE_RESULTS: internal code error'
	    PRINT *, ' maximum number of forced is too large'
	    PRINT *, ' parameter max_questions:', max_forced
	    PRINT *, ' allowed maximum is: 25'
	    PRINT *, ' '
	    CALL LIBSTOP(%VAL(ss_abort))

	  END IF

***

	  DO j = 1, 80
	  var_names(j:j) = ' '
	  END DO

c          print *,n_forced,' check del codice'

	  DO i = 1, n_forced
	  n1 = 1  +  3 * (i-1)
          n2 = (iforced(i)-1)/n_alternatives
          n3 = iforced(i)-n2*n_alternatives          
	  WRITE (var_names(n1:n1), '(A)')  letter(n2)
          WRITE (var_names(n1+1:n1+1), '(A)') letter(n3)
	  END DO

	WRITE (17, '(A)') var_names
	WRITE (17, *)     ' '
	WRITE (17, '(A)')
     &	 '************************************************************'
	WRITE (17, *)     ' '
        IF (first .EQ. 0) line_count = line_count + 3

        
        IF (first .EQ. 0) THEN
           first = 1
           write(14,*) n_questions
           write(14,*) n_forced
           write(14,*) line_count
           write(14,*) '0'
           write(14,91) (weights(i,1),i=1,n_questions)
           write(14,91) (weights(i,2),i=1,n_questions)
           write(14,*) '0'
 91	   format(25(1x,i3))
        ENDIF

	RETURN

	END
